/*
 * Heap de mximo
 */

#include <stdlib.h>
#include <stdio.h>
#include "heap.h"

int pai(int i) { return (i-1)/2; }
int esq(int i) { return 2*i + 1; }
int dir(int i) { return 2*i + 2; }

int existe_pai(int i) { return i > 0; }
int existe_esq(int i, int n) { return esq(i) < n; }
int existe_dir(int i, int n) { return dir(i) < n; }

void cria(Heap *heap, int max_n) {
  heap->h = malloc (max_n * sizeof(int));
  heap->max_n = max_n;
  heap->n = 0;
}

void destroi(Heap *heap) {
  free(heap->h);
}

int verifica(Heap *heap) {
  return 0;
}

/* Retorna 0 caso o heap j esteja cheio. */
int insere(Heap *heap, int v) {
  return 0;
}

/* Retorna o elemento mximo do heap ou -1
   caso o heap esteja vazio. */
int remove_max(Heap *heap, int *m) {
  return 0;
}



int main() {
  Heap heap;

  cria(&heap, 12);
  insere(&heap, 10);
  verifica(&heap);

  int m;
  while (remove_max(&heap, &m)) 
    if (verifica(&heap))
      printf("%d\n", m);

  return 0;
}
